# Generated File
import dataclasses
import struct
import typing

from retro_data_structures.game_check import Game
from retro_data_structures.properties.base_property import BaseProperty
from retro_data_structures.properties.prime_remastered.archetypes.LightingMP1 import LightingMP1
from retro_data_structures.properties.prime_remastered.archetypes.ScannableMP1 import ScannableMP1
from retro_data_structures.properties.prime_remastered.archetypes.VisorMP1 import VisorMP1
from retro_data_structures.properties.prime_remastered.core.AssetId import AssetId, default_asset_id
import uuid


@dataclasses.dataclass()
class ActorInformationMP1(BaseProperty):
    unk_guid_1: AssetId = dataclasses.field(metadata={'asset_types': []}, default=default_asset_id)
    unk_guid_2: AssetId = dataclasses.field(metadata={'asset_types': []}, default=default_asset_id)
    unk_guid_3: AssetId = dataclasses.field(metadata={'asset_types': []}, default=default_asset_id)
    unk_guid_4: AssetId = dataclasses.field(metadata={'asset_types': []}, default=default_asset_id)
    unk_guid_5: AssetId = dataclasses.field(metadata={'asset_types': []}, default=default_asset_id)
    unk_float_1: float = dataclasses.field(default=1.0)
    unk_bool_4: bool = dataclasses.field(default=False)
    lighting: LightingMP1 = dataclasses.field(default_factory=LightingMP1)
    scannable: ScannableMP1 = dataclasses.field(default_factory=ScannableMP1)
    visor: VisorMP1 = dataclasses.field(default_factory=VisorMP1)
    unk_float_2: float = dataclasses.field(default=1.0)
    unk_float_3: float = dataclasses.field(default=1.0)
    unk_float_4: float = dataclasses.field(default=1.0)
    unk_int: int = dataclasses.field(default=0)
    water_sort_type: int = dataclasses.field(default=0)
    unk_bool_1: bool = dataclasses.field(default=True)
    unk_bool_2: bool = dataclasses.field(default=True)
    unk_bool_3: bool = dataclasses.field(default=False)
    unk_bool_5: bool = dataclasses.field(default=False)
    unk_bool_6: bool = dataclasses.field(default=False)
    unk_bool_7: bool = dataclasses.field(default=True)
    unk_bool_8: bool = dataclasses.field(default=False)
    unk_bool_9: bool = dataclasses.field(default=False)
    unk_bool_10: bool = dataclasses.field(default=True)

    @classmethod
    def game(cls) -> Game:
        return Game.PRIME_REMASTER

    @classmethod
    def from_stream(cls, data: typing.BinaryIO, size: typing.Optional[int] = None, default_override: typing.Optional[dict] = None):
        property_count = struct.unpack("<H", data.read(2))[0]
        present_fields = default_override or {}
        for _ in range(property_count):
            property_id, property_size = struct.unpack("<LH", data.read(6))
            start = data.tell()
            try:
                property_name, decoder = _property_decoder[property_id]
                present_fields[property_name] = decoder(data, property_size)
            except KeyError:
                raise RuntimeError(f"Unknown property: 0x{property_id:08x}")
            assert data.tell() - start == property_size

        return cls(**present_fields)

    def to_stream(self, data: typing.BinaryIO, default_override: typing.Optional[dict] = None):
        default_override = default_override or {}
        num_properties_offset = data.tell()
        data.write(b'\x03\x00')  # 3 properties
        num_properties_written = 3

        if self.unk_guid_1 != default_override.get('unk_guid_1', default_asset_id):
            num_properties_written += 1
            data.write(b'x\xd76\x00')  # 0x36d778
            data.write(b'\x10\x00')  # size
            data.write(self.unk_guid_1.bytes_le)

        if self.unk_guid_2 != default_override.get('unk_guid_2', default_asset_id):
            num_properties_written += 1
            data.write(b'\xa7\xf7h\xab')  # 0xab68f7a7
            data.write(b'\x10\x00')  # size
            data.write(self.unk_guid_2.bytes_le)

        if self.unk_guid_3 != default_override.get('unk_guid_3', default_asset_id):
            num_properties_written += 1
            data.write(b':\x05*\x80')  # 0x802a053a
            data.write(b'\x10\x00')  # size
            data.write(self.unk_guid_3.bytes_le)

        if self.unk_guid_4 != default_override.get('unk_guid_4', default_asset_id):
            num_properties_written += 1
            data.write(b'7/\x82t')  # 0x74822f37
            data.write(b'\x10\x00')  # size
            data.write(self.unk_guid_4.bytes_le)

        if self.unk_guid_5 != default_override.get('unk_guid_5', default_asset_id):
            num_properties_written += 1
            data.write(b'z\xa9d\x03')  # 0x364a97a
            data.write(b'\x10\x00')  # size
            data.write(self.unk_guid_5.bytes_le)

        if self.unk_float_1 != default_override.get('unk_float_1', 1.0):
            num_properties_written += 1
            data.write(b'8\xa7\xa56')  # 0x36a5a738
            data.write(b'\x04\x00')  # size
            data.write(struct.pack('<f', self.unk_float_1))

        if self.unk_bool_4 != default_override.get('unk_bool_4', False):
            num_properties_written += 1
            data.write(b'\xa7\xccQb')  # 0x6251cca7
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_4))

        data.write(b'\xf2<\x9e\x14')  # 0x149e3cf2
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.lighting.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack("<H", after - before - 2))
        data.seek(after)

        data.write(b'<\x08\r\xe5')  # 0xe50d083c
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.scannable.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack("<H", after - before - 2))
        data.seek(after)

        data.write(b'x\x0bQ\xaf')  # 0xaf510b78
        before = data.tell()
        data.write(b'\x00\x00')  # size placeholder
        self.visor.to_stream(data)
        after = data.tell()
        data.seek(before)
        data.write(struct.pack("<H", after - before - 2))
        data.seek(after)

        if self.unk_float_2 != default_override.get('unk_float_2', 1.0):
            num_properties_written += 1
            data.write(b'U]\x07\x90')  # 0x90075d55
            data.write(b'\x04\x00')  # size
            data.write(struct.pack('<f', self.unk_float_2))

        if self.unk_float_3 != default_override.get('unk_float_3', 1.0):
            num_properties_written += 1
            data.write(b'\xfd\x9fu\x1a')  # 0x1a759ffd
            data.write(b'\x04\x00')  # size
            data.write(struct.pack('<f', self.unk_float_3))

        if self.unk_float_4 != default_override.get('unk_float_4', 1.0):
            num_properties_written += 1
            data.write(b'\xdd5Q\xde')  # 0xde5135dd
            data.write(b'\x04\x00')  # size
            data.write(struct.pack('<f', self.unk_float_4))

        if self.unk_int != default_override.get('unk_int', 0):
            num_properties_written += 1
            data.write(b'\xe8\xb4\x89\xba')  # 0xba89b4e8
            data.write(b'\x04\x00')  # size
            data.write(struct.pack('<l', self.unk_int))

        if self.water_sort_type != default_override.get('water_sort_type', 0):
            num_properties_written += 1
            data.write(b'jU"\xb2')  # 0xb222556a
            data.write(b'\x04\x00')  # size
            data.write(struct.pack('<l', self.water_sort_type))

        if self.unk_bool_1 != default_override.get('unk_bool_1', True):
            num_properties_written += 1
            data.write(b'\x18\x08A\x8a')  # 0x8a410818
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_1))

        if self.unk_bool_2 != default_override.get('unk_bool_2', True):
            num_properties_written += 1
            data.write(b'\x1bm\x06w')  # 0x77066d1b
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_2))

        if self.unk_bool_3 != default_override.get('unk_bool_3', False):
            num_properties_written += 1
            data.write(b'\xe2^@~')  # 0x7e405ee2
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_3))

        if self.unk_bool_5 != default_override.get('unk_bool_5', False):
            num_properties_written += 1
            data.write(b'\xfbQ\x07\x05')  # 0x50751fb
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_5))

        if self.unk_bool_6 != default_override.get('unk_bool_6', False):
            num_properties_written += 1
            data.write(b'\xc9]\xba\xc8')  # 0xc8ba5dc9
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_6))

        if self.unk_bool_7 != default_override.get('unk_bool_7', True):
            num_properties_written += 1
            data.write(b',:\xb2\xc7')  # 0xc7b23a2c
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_7))

        if self.unk_bool_8 != default_override.get('unk_bool_8', False):
            num_properties_written += 1
            data.write(b'\xfaN\xcaJ')  # 0x4aca4efa
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_8))

        if self.unk_bool_9 != default_override.get('unk_bool_9', False):
            num_properties_written += 1
            data.write(b']\x95\xd8j')  # 0x6ad8955d
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_9))

        if self.unk_bool_10 != default_override.get('unk_bool_10', True):
            num_properties_written += 1
            data.write(b'c\x99\xb3a')  # 0x61b39963
            data.write(b'\x01\x00')  # size
            data.write(struct.pack('<?', self.unk_bool_10))

        if num_properties_written != 3:
            struct_end_offset = data.tell()
            data.seek(num_properties_offset)
            data.write(struct.pack("<H", num_properties_written))
            data.seek(struct_end_offset)

    @classmethod
    def from_json(cls, data: dict):
        return cls(
            unk_guid_1=uuid.UUID(data['unk_guid_1']),
            unk_guid_2=uuid.UUID(data['unk_guid_2']),
            unk_guid_3=uuid.UUID(data['unk_guid_3']),
            unk_guid_4=uuid.UUID(data['unk_guid_4']),
            unk_guid_5=uuid.UUID(data['unk_guid_5']),
            unk_float_1=data['unk_float_1'],
            unk_bool_4=data['unk_bool_4'],
            lighting=LightingMP1.from_json(data['lighting']),
            scannable=ScannableMP1.from_json(data['scannable']),
            visor=VisorMP1.from_json(data['visor']),
            unk_float_2=data['unk_float_2'],
            unk_float_3=data['unk_float_3'],
            unk_float_4=data['unk_float_4'],
            unk_int=data['unk_int'],
            water_sort_type=data['water_sort_type'],
            unk_bool_1=data['unk_bool_1'],
            unk_bool_2=data['unk_bool_2'],
            unk_bool_3=data['unk_bool_3'],
            unk_bool_5=data['unk_bool_5'],
            unk_bool_6=data['unk_bool_6'],
            unk_bool_7=data['unk_bool_7'],
            unk_bool_8=data['unk_bool_8'],
            unk_bool_9=data['unk_bool_9'],
            unk_bool_10=data['unk_bool_10'],
        )

    def to_json(self) -> dict:
        return {
            'unk_guid_1': str(self.unk_guid_1),
            'unk_guid_2': str(self.unk_guid_2),
            'unk_guid_3': str(self.unk_guid_3),
            'unk_guid_4': str(self.unk_guid_4),
            'unk_guid_5': str(self.unk_guid_5),
            'unk_float_1': self.unk_float_1,
            'unk_bool_4': self.unk_bool_4,
            'lighting': self.lighting.to_json(),
            'scannable': self.scannable.to_json(),
            'visor': self.visor.to_json(),
            'unk_float_2': self.unk_float_2,
            'unk_float_3': self.unk_float_3,
            'unk_float_4': self.unk_float_4,
            'unk_int': self.unk_int,
            'water_sort_type': self.water_sort_type,
            'unk_bool_1': self.unk_bool_1,
            'unk_bool_2': self.unk_bool_2,
            'unk_bool_3': self.unk_bool_3,
            'unk_bool_5': self.unk_bool_5,
            'unk_bool_6': self.unk_bool_6,
            'unk_bool_7': self.unk_bool_7,
            'unk_bool_8': self.unk_bool_8,
            'unk_bool_9': self.unk_bool_9,
            'unk_bool_10': self.unk_bool_10,
        }


def _decode_unk_guid_1(data: typing.BinaryIO, property_size: int):
    return uuid.UUID(bytes_le=data.read(16))


def _decode_unk_guid_2(data: typing.BinaryIO, property_size: int):
    return uuid.UUID(bytes_le=data.read(16))


def _decode_unk_guid_3(data: typing.BinaryIO, property_size: int):
    return uuid.UUID(bytes_le=data.read(16))


def _decode_unk_guid_4(data: typing.BinaryIO, property_size: int):
    return uuid.UUID(bytes_le=data.read(16))


def _decode_unk_guid_5(data: typing.BinaryIO, property_size: int):
    return uuid.UUID(bytes_le=data.read(16))


def _decode_unk_float_1(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<f', data.read(4))[0]


def _decode_unk_bool_4(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_lighting(data: typing.BinaryIO, property_size: int):
    return LightingMP1.from_stream(data, property_size)


def _decode_scannable(data: typing.BinaryIO, property_size: int):
    return ScannableMP1.from_stream(data, property_size)


def _decode_visor(data: typing.BinaryIO, property_size: int):
    return VisorMP1.from_stream(data, property_size)


def _decode_unk_float_2(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<f', data.read(4))[0]


def _decode_unk_float_3(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<f', data.read(4))[0]


def _decode_unk_float_4(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<f', data.read(4))[0]


def _decode_unk_int(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<l', data.read(4))[0]


def _decode_water_sort_type(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<l', data.read(4))[0]


def _decode_unk_bool_1(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_2(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_3(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_5(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_6(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_7(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_8(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_9(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


def _decode_unk_bool_10(data: typing.BinaryIO, property_size: int):
    return struct.unpack('<?', data.read(1))[0]


_property_decoder: typing.Dict[int, typing.Tuple[str, typing.Callable[[typing.BinaryIO, int], typing.Any]]] = {
    0x36d778: ('unk_guid_1', _decode_unk_guid_1),
    0xab68f7a7: ('unk_guid_2', _decode_unk_guid_2),
    0x802a053a: ('unk_guid_3', _decode_unk_guid_3),
    0x74822f37: ('unk_guid_4', _decode_unk_guid_4),
    0x364a97a: ('unk_guid_5', _decode_unk_guid_5),
    0x36a5a738: ('unk_float_1', _decode_unk_float_1),
    0x6251cca7: ('unk_bool_4', _decode_unk_bool_4),
    0x149e3cf2: ('lighting', _decode_lighting),
    0xe50d083c: ('scannable', _decode_scannable),
    0xaf510b78: ('visor', _decode_visor),
    0x90075d55: ('unk_float_2', _decode_unk_float_2),
    0x1a759ffd: ('unk_float_3', _decode_unk_float_3),
    0xde5135dd: ('unk_float_4', _decode_unk_float_4),
    0xba89b4e8: ('unk_int', _decode_unk_int),
    0xb222556a: ('water_sort_type', _decode_water_sort_type),
    0x8a410818: ('unk_bool_1', _decode_unk_bool_1),
    0x77066d1b: ('unk_bool_2', _decode_unk_bool_2),
    0x7e405ee2: ('unk_bool_3', _decode_unk_bool_3),
    0x50751fb: ('unk_bool_5', _decode_unk_bool_5),
    0xc8ba5dc9: ('unk_bool_6', _decode_unk_bool_6),
    0xc7b23a2c: ('unk_bool_7', _decode_unk_bool_7),
    0x4aca4efa: ('unk_bool_8', _decode_unk_bool_8),
    0x6ad8955d: ('unk_bool_9', _decode_unk_bool_9),
    0x61b39963: ('unk_bool_10', _decode_unk_bool_10),
}
